; ModuleID = 'Pad1DS3Array_1.4'
source_filename = "Pad1DS3Array_1.4"
target datalayout = "e-i64:64-i128:128-v16:16-v32:32-n16:32:64"
target triple = "nvptx64-nvidia-cuda"

define void @fusion(i8* align 64 dereferenceable(16) %alloc0, i8* align 16 dereferenceable(6) %alloc1, i8* align 16 dereferenceable(2) %alloc2) {
entry:
  %pad_result_addr23 = alloca float
  %pad_result_addr16 = alloca float
  %pad_result_addr9 = alloca float
  %pad_result_addr = alloca float
  %parameter.1.raw = getelementptr inbounds i8, i8* %alloc1, i64 0
  %parameter.1.typed = bitcast i8* %parameter.1.raw to [3 x i16]*
  %parameter.2.raw = getelementptr inbounds i8, i8* %alloc2, i64 0
  %parameter.2.typed = bitcast i8* %parameter.2.raw to i16*
  %fusion.raw = getelementptr inbounds i8, i8* %alloc0, i64 0
  %fusion.typed = bitcast i8* %fusion.raw to [8 x i16]*
  %0 = call i32 @llvm.nvvm.read.ptx.sreg.ctaid.x(), !range !2
  %1 = call i32 @llvm.nvvm.read.ptx.sreg.tid.x(), !range !3
  %2 = mul nuw nsw i32 %0, 2
  %linear_index = add nuw nsw i32 %2, %1
  %linear_index_in_range = icmp ult i32 %linear_index, 2
  call void @llvm.assume(i1 %linear_index_in_range)
  %linear_index_base = mul nuw nsw i32 %linear_index, 4
  %3 = udiv i32 %linear_index_base, 1
  %linear_index1 = add nuw nsw i32 %linear_index_base, 1
  %4 = udiv i32 %linear_index1, 1
  %linear_index2 = add nuw nsw i32 %linear_index_base, 2
  %5 = udiv i32 %linear_index2, 1
  %linear_index3 = add nuw nsw i32 %linear_index_base, 3
  %6 = udiv i32 %linear_index3, 1
  %7 = icmp ult i32 %linear_index_base, 8
  br i1 %7, label %fusion.in_bounds-true, label %fusion.in_bounds-after

fusion.in_bounds-after:                           ; preds = %in_bounds-after26, %entry
  ret void

fusion.in_bounds-true:                            ; preds = %entry
  %8 = sub i32 %3, 3
  %9 = icmp sge i32 %8, 0
  %in_bounds = and i1 true, %9
  %10 = urem i32 %8, 2
  %11 = icmp eq i32 0, %10
  %in_bounds4 = and i1 %in_bounds, %11
  %12 = sdiv i32 %8, 2
  %13 = icmp slt i32 %12, 3
  %in_bounds5 = and i1 %in_bounds4, %13
  br i1 %in_bounds5, label %in_bounds-true, label %in_bounds-false

in_bounds-after:                                  ; preds = %in_bounds-false, %in_bounds-true
  %14 = load float, float* %pad_result_addr
  %15 = bitcast float %14 to i32
  %16 = and i32 %15, 65536
  %17 = lshr i32 %16, 16
  %18 = add i32 %17, 32767
  %19 = add i32 %15, %18
  %20 = and i32 %19, -65536
  %21 = bitcast i32 %20 to float
  %22 = fcmp uno float %14, %14
  %23 = select i1 %22, float %14, float %21
  %24 = bitcast float %23 to i32
  %25 = lshr i32 %24, 16
  %26 = trunc i32 %25 to i16
  %27 = bitcast [8 x i16]* %fusion.typed to i16*
  %28 = getelementptr inbounds i16, i16* %27, i32 %linear_index_base
  store i16 %26, i16* %28, !alias.scope !4
  %29 = sub i32 %4, 3
  %30 = icmp sge i32 %29, 0
  %in_bounds6 = and i1 true, %30
  %31 = urem i32 %29, 2
  %32 = icmp eq i32 0, %31
  %in_bounds7 = and i1 %in_bounds6, %32
  %33 = sdiv i32 %29, 2
  %34 = icmp slt i32 %33, 3
  %in_bounds8 = and i1 %in_bounds7, %34
  br i1 %in_bounds8, label %in_bounds-true10, label %in_bounds-false11

in_bounds-after12:                                ; preds = %in_bounds-false11, %in_bounds-true10
  %35 = load float, float* %pad_result_addr9
  %36 = bitcast float %35 to i32
  %37 = and i32 %36, 65536
  %38 = lshr i32 %37, 16
  %39 = add i32 %38, 32767
  %40 = add i32 %36, %39
  %41 = and i32 %40, -65536
  %42 = bitcast i32 %41 to float
  %43 = fcmp uno float %35, %35
  %44 = select i1 %43, float %35, float %42
  %45 = bitcast float %44 to i32
  %46 = lshr i32 %45, 16
  %47 = trunc i32 %46 to i16
  %48 = bitcast [8 x i16]* %fusion.typed to i16*
  %49 = getelementptr inbounds i16, i16* %48, i32 %linear_index1
  store i16 %47, i16* %49, !alias.scope !4
  %50 = sub i32 %5, 3
  %51 = icmp sge i32 %50, 0
  %in_bounds13 = and i1 true, %51
  %52 = urem i32 %50, 2
  %53 = icmp eq i32 0, %52
  %in_bounds14 = and i1 %in_bounds13, %53
  %54 = sdiv i32 %50, 2
  %55 = icmp slt i32 %54, 3
  %in_bounds15 = and i1 %in_bounds14, %55
  br i1 %in_bounds15, label %in_bounds-true17, label %in_bounds-false18

in_bounds-after19:                                ; preds = %in_bounds-false18, %in_bounds-true17
  %56 = load float, float* %pad_result_addr16
  %57 = bitcast float %56 to i32
  %58 = and i32 %57, 65536
  %59 = lshr i32 %58, 16
  %60 = add i32 %59, 32767
  %61 = add i32 %57, %60
  %62 = and i32 %61, -65536
  %63 = bitcast i32 %62 to float
  %64 = fcmp uno float %56, %56
  %65 = select i1 %64, float %56, float %63
  %66 = bitcast float %65 to i32
  %67 = lshr i32 %66, 16
  %68 = trunc i32 %67 to i16
  %69 = bitcast [8 x i16]* %fusion.typed to i16*
  %70 = getelementptr inbounds i16, i16* %69, i32 %linear_index2
  store i16 %68, i16* %70, !alias.scope !4
  %71 = sub i32 %6, 3
  %72 = icmp sge i32 %71, 0
  %in_bounds20 = and i1 true, %72
  %73 = urem i32 %71, 2
  %74 = icmp eq i32 0, %73
  %in_bounds21 = and i1 %in_bounds20, %74
  %75 = sdiv i32 %71, 2
  %76 = icmp slt i32 %75, 3
  %in_bounds22 = and i1 %in_bounds21, %76
  br i1 %in_bounds22, label %in_bounds-true24, label %in_bounds-false25

in_bounds-after26:                                ; preds = %in_bounds-false25, %in_bounds-true24
  %77 = load float, float* %pad_result_addr23
  %78 = bitcast float %77 to i32
  %79 = and i32 %78, 65536
  %80 = lshr i32 %79, 16
  %81 = add i32 %80, 32767
  %82 = add i32 %78, %81
  %83 = and i32 %82, -65536
  %84 = bitcast i32 %83 to float
  %85 = fcmp uno float %77, %77
  %86 = select i1 %85, float %77, float %84
  %87 = bitcast float %86 to i32
  %88 = lshr i32 %87, 16
  %89 = trunc i32 %88 to i16
  %90 = bitcast [8 x i16]* %fusion.typed to i16*
  %91 = getelementptr inbounds i16, i16* %90, i32 %linear_index3
  store i16 %89, i16* %91, !alias.scope !4
  br label %fusion.in_bounds-after

in_bounds-true:                                   ; preds = %fusion.in_bounds-true
  %92 = getelementptr inbounds [3 x i16], [3 x i16]* %parameter.1.typed, i32 0, i32 %12
  %93 = load i16, i16* %92, !invariant.load !7, !noalias !4
  %94 = zext i16 %93 to i32
  %95 = shl i32 %94, 16
  %96 = bitcast i32 %95 to float
  store float %96, float* %pad_result_addr
  br label %in_bounds-after

in_bounds-false:                                  ; preds = %fusion.in_bounds-true
  %97 = load i16, i16* %parameter.2.typed, !invariant.load !7, !noalias !4
  %98 = zext i16 %97 to i32
  %99 = shl i32 %98, 16
  %100 = bitcast i32 %99 to float
  store float %100, float* %pad_result_addr
  br label %in_bounds-after

in_bounds-true10:                                 ; preds = %in_bounds-after
  %101 = getelementptr inbounds [3 x i16], [3 x i16]* %parameter.1.typed, i32 0, i32 %33
  %102 = load i16, i16* %101, !invariant.load !7, !noalias !4
  %103 = zext i16 %102 to i32
  %104 = shl i32 %103, 16
  %105 = bitcast i32 %104 to float
  store float %105, float* %pad_result_addr9
  br label %in_bounds-after12

in_bounds-false11:                                ; preds = %in_bounds-after
  %106 = load i16, i16* %parameter.2.typed, !invariant.load !7, !noalias !4
  %107 = zext i16 %106 to i32
  %108 = shl i32 %107, 16
  %109 = bitcast i32 %108 to float
  store float %109, float* %pad_result_addr9
  br label %in_bounds-after12

in_bounds-true17:                                 ; preds = %in_bounds-after12
  %110 = getelementptr inbounds [3 x i16], [3 x i16]* %parameter.1.typed, i32 0, i32 %54
  %111 = load i16, i16* %110, !invariant.load !7, !noalias !4
  %112 = zext i16 %111 to i32
  %113 = shl i32 %112, 16
  %114 = bitcast i32 %113 to float
  store float %114, float* %pad_result_addr16
  br label %in_bounds-after19

in_bounds-false18:                                ; preds = %in_bounds-after12
  %115 = load i16, i16* %parameter.2.typed, !invariant.load !7, !noalias !4
  %116 = zext i16 %115 to i32
  %117 = shl i32 %116, 16
  %118 = bitcast i32 %117 to float
  store float %118, float* %pad_result_addr16
  br label %in_bounds-after19

in_bounds-true24:                                 ; preds = %in_bounds-after19
  %119 = getelementptr inbounds [3 x i16], [3 x i16]* %parameter.1.typed, i32 0, i32 %75
  %120 = load i16, i16* %119, !invariant.load !7, !noalias !4
  %121 = zext i16 %120 to i32
  %122 = shl i32 %121, 16
  %123 = bitcast i32 %122 to float
  store float %123, float* %pad_result_addr23
  br label %in_bounds-after26

in_bounds-false25:                                ; preds = %in_bounds-after19
  %124 = load i16, i16* %parameter.2.typed, !invariant.load !7, !noalias !4
  %125 = zext i16 %124 to i32
  %126 = shl i32 %125, 16
  %127 = bitcast i32 %126 to float
  store float %127, float* %pad_result_addr23
  br label %in_bounds-after26
}

; Function Attrs: nounwind readnone
declare i32 @llvm.nvvm.read.ptx.sreg.ctaid.x() #0

; Function Attrs: nounwind readnone
declare i32 @llvm.nvvm.read.ptx.sreg.tid.x() #0

; Function Attrs: nounwind willreturn
declare void @llvm.assume(i1) #1

attributes #0 = { nounwind readnone }
attributes #1 = { nounwind willreturn }

!nvvm.annotations = !{!0, !1}

!0 = !{void (i8*, i8*, i8*)* @fusion, !"kernel", i32 1}
!1 = !{void (i8*, i8*, i8*)* @fusion, !"reqntidx", i32 2}
!2 = !{i32 0, i32 1}
!3 = !{i32 0, i32 2}
!4 = !{!5}
!5 = !{!"buffer: {index:0, offset:0, size:16}", !6}
!6 = !{!"XLA global AA domain"}
!7 = !{}
